#pragma once

#include <string>
#include <map>
#include <vector>
#include <fstream>
#include <iostream>
#include <algorithm>
#include <iomanip>

struct Mark
{
	char subject[20];
	int mark;

	//!!!      ,        
	//!!!   


	Mark() = default;

	~Mark() = default;

	Mark(const Mark& _mark)
	{
		this->mark = _mark.mark;
		for (int i = 0; i < 20; i++)
		{
			this->subject[i] = _mark.subject[i];
		}
	}

	Mark& operator = (const Mark& _mark)
	{
	    //!!! Нет проверки на самоприсваивание
	    
		this->mark = _mark.mark;
		for (int i = 0; i < 20; i++)
		{
			this->subject[i] = _mark.subject[i];
		}
		return (*this);
	}

	bool operator == (const Mark& to_cmp) //!!!     
	{
		return strcmp(to_cmp.subject, subject) == 0 && to_cmp.mark == mark;
	}

	friend std::ostream& operator <<(std::ostream& out, const Mark& p_mark)
	{
		out << p_mark.subject << ": " << p_mark.mark;
		return out;
	}
};



struct Record
{
	friend struct Mark;

	int course;
	char group[10];
	char surname[30];
	char id[10];
	Mark mark[5];
	size_t mark_size;

	//!!!      ,        
	//!!!   
	Record() = default;

	~Record() = default;

	Record(const Record& _record)
	{

		this->course = _record.course;
		this->mark_size = _record.mark_size;

		for (int i = 0; i < 10; i++)
		{
			this->group[i] = _record.group[i];
		}

		for (int i = 0; i < 30; i++)
		{
			this->surname[i] = _record.surname[i];
		}

		for (int i = 0; i < 10; i++)
		{
			this->id[i] = _record.id[i];
		}

		for (int i = 0; i < 5; i++)
		{
			this->mark[i] = _record.mark[i];
		}
	}


	Record& operator=(const Record& _record)
	{

		this->course = _record.course;
		this->mark_size = _record.mark_size;

		for (int i = 0; i < 10; i++)
		{
			this->group[i] = _record.group[i];
		}

		for (int i = 0; i < 30; i++)
		{
			this->surname[i] = _record.surname[i];
		}

		for (int i = 0; i < 10; i++)
		{
			this->id[i] = _record.id[i];
		}

		for (int i = 0; i < 5; i++)
		{
			this->mark[i] = _record.mark[i];
		}

		return (*this);
	}

	bool operator == (const Record& to_cmp) const
	{
		bool tmp = false;
		if (to_cmp.mark_size != mark_size)
			return false;
		for (int i = 0; i < mark_size; i++)
		{
			if (!(strcmp(to_cmp.mark[i].subject, mark[i].subject) == 0 && to_cmp.mark[i].mark == mark[i].mark))
			{
				tmp = false;
				break;
			}
			else tmp = true;
		}
		return course == to_cmp.course
			&& strcmp(group, to_cmp.group) == 0
			&& strcmp(surname, to_cmp.surname) == 0
			&& strcmp(id, to_cmp.id) == 0
			&& tmp;
	}
};


void outputMark(const Mark& curr);

void inputMark(Mark* curr, size_t p_size);

void insertNewRecord(Record& newRec);

void outputRecord(const Record& rec);

void createAndWrite(const std::string& fileName);



class cl_Journal
{
private:
	std::map<size_t, Record> session;
	std::string base_fileName;
	size_t f_amount;

	void load_in();
	void load_out();

public:
	cl_Journal(const std::string&);
	~cl_Journal();

	bool add_record(const Record& rec);
	bool add_record(Record&& rec);

	bool search_record(const Record& rec);
	bool search_record(const int& p_course);
	bool search_record_group(const std::string& p_group);
	bool search_record_surname(const std::string& p_surname);
	bool search_record_id(const std::string& p_id);
	bool search_record(const Mark* p_mark);

	bool delete_record(const Record& rec);

	bool change_record(const Record& toChange, const Record& toImply);

	bool avg_subject(const std::string& p_subject);
	bool avg_course(int p_course);
	bool avg_group(const std::string& p_group);

	void loadOutTXT();
};

